﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Activity
Version=9.8
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: False
	#IncludeTitle: False
#End Region

Sub Process_Globals
	Dim xui As XUI
End Sub

Sub Globals
	Private Drawer As B4XDrawer
	Private CLVL As CustomListView
	Private CLVM As CustomListView
	Private imgProfile As ImageView	
	Private lblProfileName As Label
	Private lblMenuIcon As Label
	Private lblMenuText As Label
	Private pnlStatus As Panel
	Private lblName As Label
	Private btnMenu As Label
	Private pnlBlur As Panel	
	Private lblViewUserName As Label
	Private lblViewUserLocation As Label
	Private txtViewUserLocation As EditText
	Private lblViewUserStatus As Label		
End Sub

Sub Activity_Create(FirstTime As Boolean)
	Drawer.Initialize(Me, "Drawer", Activity, 300dip)
	Drawer.LeftPanel.LoadLayout("LeftMenu")
	Drawer.CenterPanel.LoadLayout("Home")
	If FirstTime Then

	End If
End Sub

Sub Activity_Resume
	LoadSlideMenu
	If Starter.gLogin > 0 Then		
		GetUserList
	End If
End Sub

Sub Activity_Pause (UserClosed As Boolean)

End Sub

Sub Activity_KeyPress (KeyCode As Int) As Boolean
	If KeyCode = KeyCodes.KEYCODE_BACK And Drawer.LeftOpen Then
		Drawer.LeftOpen = False
		Return True
	End If
	Return False
End Sub

Sub btnMenu_Click
	Drawer.LeftOpen = Not(Drawer.LeftOpen)
End Sub

Sub CLVL_ItemClick (Index As Int, Value As Object)
	Drawer.LeftOpen = False
	Select Case Value
		Case "Log in"
			AppUser.strMode = "Login"
			StartActivity(AppUser)
		Case "Register"
			AppUser.strMode = "Register"
			StartActivity(AppUser)
		Case "Change Password"
			AppPassword.strMode = "Change"
			StartActivity(AppPassword)
		Case "About Me"
			AppUser.strMode = "About"
			StartActivity(AppUser)
		Case "Log out"
			Starter.gLogin = 0
			StartActivity(Main)
			Activity.Finish
	End Select
End Sub

Sub LoadSlideMenu
	CLVL.Clear
	If Starter.gLogin = 0 Then
		CLVL.Add(CreateMenu(Chr(0xF090), "Log in", CLVL.AsView.Width), "Log in")
		CLVL.Add(CreateMenu(Chr(0xF234), "Register", CLVL.AsView.Width), "Register")
	Else
		lblProfileName.Text = Starter.gUserName
		CLVL.Add(CreateMenu(Chr(0xF05A), "About Me", CLVL.AsView.Width), "About Me")
		CLVL.Add(CreateMenu(Chr(0xF013), "Change Password", CLVL.AsView.Width), "Change Password")
		CLVL.Add(CreateMenu(Chr(0xF08B), "Log out", CLVL.AsView.Width), "Log out")
	End If
	CLVL.AnimationDuration = 0	
	' Reference: https://www.b4x.com/android/forum/threads/b4x-xui-create-a-round-image.85102/
	Dim xIV As B4XView = imgProfile
	Dim img As B4XBitmap = xui.LoadBitmapResize(File.DirAssets, "default.png", imgProfile.Width, imgProfile.Height, False)
	xIV.SetBitmap(CreateRoundBitmap(img, xIV.Width))
End Sub

Sub GetUserList
	Dim parser As JSONParser
	Dim Job As HttpJob
	Dim List1 As List
	Dim Map1 As Map
	Dim strError As String
	Dim strData As String
	Dim jsn As String
	Dim Rows As Int
	Dim intListUserID As Int
	Dim strListUserName As String
	Dim strListUserStatus As String	
	Try
		If Starter.gUserAPIKey = "" Then
			ToastMessageShow("Error: Invalid API Key. Try Login again.", False)
			Return
		End If
		LogColor("[AppHome] GetUserList", Colors.Blue)
		Job.Initialize("", Me)
		ProgressDialogShow("Connecting to server...")
		Job.Download(Starter.strURL & "user/connect")
		Wait For (Job) JobDone(Job As HttpJob)
		ProgressDialogHide
		If Job.Success Then
			strData = Job.GetString
			Log(strData)
			Job.Release
			parser.Initialize(strData)
			If Routine.isArray(strData) Then
				List1 = parser.NextArray
				Map1 = List1.Get(0)
				If Map1.Get("Connected") = 1 Then
					ProgressDialogShow("Retrieving data...")					
					Dim Map2 As Map
					Map2.Initialize
					Map2.Put("key", Starter.gUserAPIKey)
					jsn = Routine.Map2Json(Map2)
					'Log(jsn)
					Job.Initialize("", Me)
					Job.PostString(Starter.strURL & "user/view/all", jsn)
					Wait For (Job) JobDone(Job As HttpJob)
					ProgressDialogHide
					If Job.Success Then
						strData = Job.GetString
						Log(strData)
						parser.Initialize(strData)
						If Routine.isArray(strData) Then
							List1 = parser.NextArray
							Map1 = List1.Get(0)
							If Map1.Get("result") = -1 Then
								If Map1.Get("message") = "Error-No-Result" Then
									ToastMessageShow("Message: No Results", False)
								Else If Map1.Get("message") = "Error-No-Value" Then
									ToastMessageShow("Error: Invalid Parameters", False)
								Else
									ToastMessageShow("Error: Uncaught error" & CRLF & Map1.Get("message"), False)
								End If
								Return
							End If							
							If List1.Size < 1 Then
								Return
							End If
							Rows = List1.Size
							CLVM.Clear
							For i = 0 To Rows - 1
								Map1 = List1.Get(i)
								intListUserID = Map1.Get("result")
								strListUserName = Map1.Get("user_name")
								strListUserStatus = Map1.Get("online")
								CLVM.Add(CreateList(strListUserName, strListUserStatus, CLVM.AsView.Width), intListUserID)
							Next
						Else
							strData = parser.NextValue
							Log(strData)
							ToastMessageShow("Error: Uncaught error" & CRLF & strData, False)
						End If
					Else
						strError = Job.ErrorMessage
						Job.Release
						Log(strError)
						Routine.ShowConnectionError(strError)
					End If
				End If
			Else
				strData = parser.NextValue
				Log(strData)
				ToastMessageShow("Error: Uncaught error" & CRLF & strData, False)
			End If
		Else
			strError = Job.ErrorMessage
			Job.Release
			Log(strError)
			Routine.ShowConnectionError(strError)
		End If
	Catch
		Job.Release
		LogColor("[AppHome] GetUserList: " & LastException.Message, Colors.Red)
		ToastMessageShow("Failed to retrieve data", False)
	End Try
End Sub

Sub GetUserInfo(id As Int)
	Dim parser As JSONParser
	Dim Job As HttpJob
	Dim List1 As List
	Dim Map1 As Map
	Dim strError As String
	Dim strData As String
	Dim jsn As String
	Try
		If Starter.gUserAPIKey = "" Then
			ToastMessageShow("Error: Invalid API Key. Try Login again.", False)
			Return
		End If
		LogColor("[AppHome] GetUserInfo", Colors.Blue)
		Job.Initialize("", Me)
		ProgressDialogShow("Connecting to server...")
		Job.Download(Starter.strURL & "user/connect")
		Wait For (Job) JobDone(Job As HttpJob)
		ProgressDialogHide
		If Job.Success Then
			strData = Job.GetString
			Log(strData)
			Job.Release
			parser.Initialize(strData)
			If Routine.isArray(strData) Then
				List1 = parser.NextArray
				Map1 = List1.Get(0)
				If Map1.Get("Connected") = 1 Then
					ProgressDialogShow("Retrieving data...")
					Dim Map2 As Map
					Map2.Initialize
					Map2.Put("key", Starter.gUserAPIKey)
					jsn = Routine.Map2Json(Map2)
					Log(jsn)
					Job.Initialize("", Me)
					Job.PostString(Starter.strURL & "user/view/" & id, jsn)
					Wait For (Job) JobDone(Job As HttpJob)
					ProgressDialogHide
					If Job.Success Then
						strData = Job.GetString
						Log(strData)
						parser.Initialize(strData)
						If Routine.isArray(strData) Then
							List1 = parser.NextArray
							Map1 = List1.Get(0)
							If Map1.Get("result") = -1 Then
								If Map1.Get("message") = "Error-No-Result" Then
									ToastMessageShow("Message: No Results", False)
								Else If Map1.Get("message") = "Error-No-Value" Then
									ToastMessageShow("Error: Invalid Parameters", False)
								Else
									ToastMessageShow("Error: Uncaught error" & CRLF & Map1.Get("message"), False)
								End If
								Return
							End If
							If List1.Size < 1 Then
								Return
							End If
							Map1 = List1.Get(0)
							lblViewUserName.Text = Map1.Get("user_name")
							txtViewUserLocation.Text = Map1.Get("user_location")
							If Map1.Get("online") = "Y" Then
								lblViewUserStatus.Text = "Online"
								lblViewUserStatus.TextColor = Colors.RGB(50, 205, 50)
							Else
								lblViewUserStatus.Text = "Offline"
								lblViewUserStatus.TextColor = Colors.RGB(105, 105, 105)
							End If
							pnlBlur.Visible = True
							Drawer.GestureEnabled = False
							btnMenu.Enabled = False
						Else
							strData = parser.NextValue
							Log(strData)
							ToastMessageShow("Error: Uncaught error" & CRLF & strData, False)
						End If
					Else
						strError = Job.ErrorMessage
						Job.Release
						Log(strError)
						Routine.ShowConnectionError(strError)
					End If
				End If
			Else
				strData = parser.NextValue
				Log(strData)
				ToastMessageShow("Error: Uncaught error" & CRLF & strData, False)
			End If
		Else
			strError = Job.ErrorMessage
			Job.Release
			Log(strError)
			Routine.ShowConnectionError(strError)
		End If
	Catch
		Job.Release
		LogColor("[AppHome] GetUserInfo: " & LastException.Message, Colors.Red)
		ToastMessageShow("Failed to retrieve data", False)
	End Try
End Sub

Private Sub CreateMenu(MenuIcon As String, MenuText As String, Width As Long) As Panel
	Dim Height As Int = 60dip
	Dim p As B4XView = xui.CreatePanel("")
	p.SetLayoutAnimated(0, 0, 0, Width, Height)
	p.LoadLayout("MenuItem")
	lblMenuIcon.Text = MenuIcon
	lblMenuText.Text = MenuText
	Return p
End Sub

Private Sub CreateList(ListText As String, ListStatus As String, Width As Long) As Panel
	Dim Height As Int = 60dip
	Dim p As B4XView = xui.CreatePanel("")
	p.SetLayoutAnimated(0, 0, 0, Width, Height)
	p.LoadLayout("ListItem")
	lblName.Text = ListText
	If ListStatus = "Y" Then
		pnlStatus.Color = Colors.Green
	Else
		pnlStatus.Color = Colors.Gray
	End If	
	Return p
End Sub

'xui is a global XUI variable.
Sub CreateRoundBitmap (Input As B4XBitmap, Size As Int) As B4XBitmap
	If Input.Width <> Input.Height Then
		'if the image is not square then we crop it to be a square.
		Dim l As Int = Min(Input.Width, Input.Height)
		Input = Input.Crop(Input.Width / 2 - l / 2, Input.Height / 2 - l / 2, l, l)
	End If
	Dim c As B4XCanvas
	Dim xview As B4XView = xui.CreatePanel("")
	xview.SetLayoutAnimated(0, 0, 0, Size, Size)
	c.Initialize(xview)
	Dim path As B4XPath
	path.InitializeOval(c.TargetRect)
	c.ClipPath(path)
	c.DrawBitmap(Input.Resize(Size, Size, False), c.TargetRect)
	c.RemoveClip
	c.DrawCircle(c.TargetRect.CenterX, c.TargetRect.CenterY, c.TargetRect.Width / 2 - 1dip, xui.Color_LightGray, False, 2dip) 'comment this line to remove the border
	c.Invalidate
	Dim res As B4XBitmap = c.CreateBitmap
	c.Release
	Return res
End Sub

Sub CLVM_ItemClick (Index As Int, Value As Object)
	GetUserInfo(Value)
End Sub

Sub lblClose_Click
	pnlBlur.Visible = False
	Drawer.GestureEnabled = True
	btnMenu.Enabled = True
End Sub

Sub NoScroll_Click
	
End Sub