﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Activity
Version=9.8
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: False
	#IncludeTitle: False
#End Region

Sub Process_Globals
	Dim strMode As String
End Sub

Sub Globals
	Dim IME As IME
	Private txtUserEmail As EditText
	Private txtOldPassword As EditText
	Private txtUserPassword1 As EditText
	Private txtUserPassword2 As EditText
End Sub

Sub Activity_Create(FirstTime As Boolean)
	IME.Initialize("IME")
End Sub

Sub Activity_Resume
	SelectMode
End Sub

Sub Activity_Pause (UserClosed As Boolean)

End Sub

Sub SelectMode
	Select Case strMode
		Case "Change"
			Activity.RemoveAllViews
			Activity.LoadLayout("Change")
			IME.SetLengthFilter(txtOldPassword, 20)
			IME.SetLengthFilter(txtUserPassword1, 20)
			IME.SetLengthFilter(txtUserPassword2, 20)
		Case "Reset"
			Activity.RemoveAllViews
			Activity.LoadLayout("Reset")
			IME.SetLengthFilter(txtUserEmail, 200)
			txtUserEmail.RequestFocus
	End Select
End Sub

Sub lblBack_Click
	IME.HideKeyboard
	Activity.Finish
End Sub

Sub btnSubmit_Click
	IME.HideKeyboard
	Select Case strMode
		Case "Change"
			If txtOldPassword.Text.Trim = "" Then
				MsgboxAsync("Please enter your Current Password", "E R R O R")
				Return
			End If
			If txtUserPassword1.Text.Trim = "" Then
				MsgboxAsync("Please enter your New Password", "E R R O R")
				Return
			End If
			If txtUserPassword2.Text.Trim = "" Then
				MsgboxAsync("Please confirm your Password", "E R R O R")
				Return
			End If
			If txtUserPassword1.Text.Trim <> txtUserPassword2.Text.Trim Then
				MsgboxAsync("Password not match", "E R R O R")
				Return
			End If
			Msgbox2Async("Are you sure to change password?", "C O N F I R M", "Y E S", "", "N O", Null, True)
			Wait For Msgbox_Result (Result As Int)
			If Result = DialogResponse.POSITIVE Then
				ChangePassword(txtOldPassword.Text.Trim, txtUserPassword1.Text.Trim)
			End If
			Return
		Case "Reset"
			If txtUserEmail.Text.Trim = "" Then
				MsgboxAsync("Please enter your Email", "E R R O R")
				Return
			End If
			If Routine.ValidateEmail(txtUserEmail.Text.Trim) = False Then
				MsgboxAsync("Email format is incorrect", "E R R O R")
				Return
			End If
			Msgbox2Async("Are you sure to reset password?", "C O N F I R M", "Y E S", "", "N O", Null, True)
			Wait For Msgbox_Result (Result As Int)
			If Result = DialogResponse.POSITIVE Then
				ResetPassword(txtUserEmail.Text.Trim)
			End If
			Return
	End Select	
End Sub

Sub ChangePassword(strOldPassword As String, strNewPassword As String)
	Dim parser As JSONParser
	Dim job As HttpJob
	Dim List1 As List
	Dim Map1 As Map
	Dim strError As String
	Dim strData As String
	Dim jsn As String
	Try
		LogColor("[AppPassword] ChangePassword", Colors.Blue)
		ProgressDialogShow("Connecting to server...")
		job.Initialize("", Me)
		job.Download(Starter.strURL & "user/connect")
		Wait For (job) JobDone(job As HttpJob)
		ProgressDialogHide
		If job.Success Then
			strData = job.GetString
			'Log(strData)
			job.Release
			parser.Initialize(strData)
			If Routine.isArray(strData) Then
				List1 = parser.NextArray
				Map1 = List1.Get(0)
				If Map1.Get("Connected") = 1 Then
					ProgressDialogShow("Calling API...")
					Dim Map2 As Map
					Map2.Initialize
					Map2.Put("eml", Starter.gUserEmail)
					Map2.Put("old", strOldPassword)
					Map2.Put("new", strNewPassword)
					jsn = Routine.Map2Json(Map2)
					job.Initialize("", Me)
					job.PostString(Starter.strURL & "password/change", jsn)
					Wait For (job) JobDone(job As HttpJob)
					ProgressDialogHide
					If job.Success Then
						strData = job.GetString
						job.Release
						Log(strData)
						parser.Initialize(strData)
						If Routine.isArray(strData) Then
							List1 = parser.NextArray
							Map1 = List1.Get(0)
							If Map1.Get("result") = -1 Then
								If Map1.Get("message") = "Error-No-Result" Then
									ToastMessageShow("Error: Invalid Password", False)
								Else If Map1.Get("message") = "Error-No-Value" Then
									ToastMessageShow("Error: Invalid Parameters", False)
								Else If Map1.Get("message") = "Error-Same-Value" Then
									ToastMessageShow("Error: Password cannot be same", False)
								Else
									ToastMessageShow("Error: Uncaught error" & CRLF & Map1.Get("message"), False)
								End If
								Return
							End If
							If Map1.Get("message") = "success" Then
								ToastMessageShow("Password change successfully!", False)
							End If
							Activity.Finish
						Else
							job.Release
							strData = parser.NextValue
							Log(strData)
							ToastMessageShow("Error: Uncaught error" & CRLF & strData, False)
						End If
					Else
						strError = job.ErrorMessage
						job.Release
						Log(strError)
						Routine.ShowConnectionError(strError)
					End If
				End If
			Else
				job.Release
				strData = parser.NextValue
				Log(strData)
				ToastMessageShow("Error: Uncaught error" & CRLF & strData, False)
			End If
		Else
			strError = job.ErrorMessage
			job.Release
			Log(strError)
			Routine.ShowConnectionError(strError)
		End If
	Catch
		job.Release
		LogColor("[AppPassword] ChangePassword: " & LastException.Message, Colors.Red)
		ToastMessageShow("Failed to change password", False)
	End Try
End Sub

Sub ResetPassword(strUserEmail As String)
	Dim parser As JSONParser
	Dim job As HttpJob
	Dim List1 As List
	Dim Map1 As Map
	Dim strError As String
	Dim strData As String
	Dim jsn As String
	Try
		LogColor("[AppPassword] ResetPassword", Colors.Blue)
		ProgressDialogShow("Connecting to server...")
		job.Initialize("", Me)
		job.Download(Starter.strURL & "user/connect")
		Wait For (job) JobDone(job As HttpJob)
		ProgressDialogHide
		If job.Success Then
			strData = job.GetString
			'Log(strData)
			job.Release
			parser.Initialize(strData)
			If Routine.isArray(strData) Then
				List1 = parser.NextArray
				Map1 = List1.Get(0)
				If Map1.Get("Connected") = 1 Then
					ProgressDialogShow("Calling API...")
					Dim Map2 As Map
					Map2.Initialize
					Map2.Put("eml", strUserEmail)
					jsn = Routine.Map2Json(Map2)
					job.Initialize("", Me)
					job.PostString(Starter.strURL & "password/reset", jsn)
					Wait For (job) JobDone(job As HttpJob)
					ProgressDialogHide
					If job.Success Then
						strData = job.GetString
						job.Release
						Log(strData)
						parser.Initialize(strData)
						If Routine.isArray(strData) Then
							List1 = parser.NextArray
							Map1 = List1.Get(0)
							If Map1.Get("result") = -1 Then
								If Map1.Get("message") = "Error-No-Result" Then
									ToastMessageShow("Error: Invalid Email", False)
								Else If Map1.Get("message") = "Error-No-Value" Then
									ToastMessageShow("Error: Invalid Parameters", False)
								Else
									ToastMessageShow("Error: Uncaught error" & CRLF & Map1.Get("message"), False)
								End If
								Return
							End If
							If Map1.Get("message") = "success" Then
								ToastMessageShow("Password reset has been requested successfully!", False)
							End If
							Activity.Finish
						Else
							job.Release
							strData = parser.NextValue
							Log(strData)
							ToastMessageShow("Error: Uncaught error" & CRLF & strData, False)
						End If
					Else
						strError = job.ErrorMessage
						job.Release
						Log(strError)
						Routine.ShowConnectionError(strError)
					End If
				End If
			Else
				job.Release
				strData = parser.NextValue
				Log(strData)
				ToastMessageShow("Error: Uncaught error" & CRLF & strData, False)
			End If
		Else
			strError = job.ErrorMessage
			job.Release
			Log(strError)
			Routine.ShowConnectionError(strError)
		End If
	Catch
		job.Release
		LogColor("[AppPassword] ResetPassword: " & LastException.Message, Colors.Red)
		ToastMessageShow("Failed to reset password", False)
	End Try
End Sub